<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstance" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.RSSInstance" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" language="JavaScript" src="js/uiValidator.js"></script>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
                       topPage="true" request="<%=request%>" label="admin.console.header"/>

    <%
        Log log = LogFactory.getLog(this.getClass());
        String strDatabaseInsId = request.getParameter("dbInsId");
        int dbInsId = (strDatabaseInsId == null) ? 0 : Integer.parseInt(strDatabaseInsId);
        String strRssInsId = request.getParameter("rssInsId");
        int rssInsId = (strRssInsId == null) ? 0 : Integer.parseInt(strRssInsId);

        String username = request.getParameter("username");
        String password = request.getParameter("password");
        username = (username == null) ? "" : username;
        password = (password == null) ? "" : password;

        AdminConsoleClient client;
        RSSInstance rssIns = null;
        DatabaseInstance db = null;

        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
                getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        try {
            client = new AdminConsoleClient(cookie, backendServerURL, configContext);
            db = client.getDatabaseInstanceInfo(rssInsId, dbInsId);
            rssIns = client.getRSSInstanceById(rssInsId);
        } catch (Exception e) {
            String errorMsg = e.getLocalizedMessage();
        }

    %>

    <div id="middle">
        <h2><fmt:message key="admin.console.add.new.user"/></h2>

        <div id="workArea">
            <form method="post" action="userProcessor.jsp" name="dataForm" onsubmit="return validatePrivileges();checkSelectedPrivileges()">
                <table class="styledLeft" id="dbGeneralInfo">
                    <thead>
                    <tr>
                        <th width="20%"><fmt:message key="admin.console.property.name"/></th>
                        <th width="60%"><fmt:message key="admin.console.value"/></th>
                    </tr>
                    </thead>
                    <tbody>
                            <input id="host" name="host" type="hidden" readonly="readonly" value="<%=(rssIns != null) ? rssIns.getName() : "Undefined"%>"/>
                            <input type="hidden" name="rssInsId" id="rssInsId" value="<%=rssInsId%>"/>
                            <input type="hidden" name="dbInsId" id="dbInsId" value="<%=(db != null) ? db.getDatabaseInstanceId() : 0%>"/>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.username"/></td>
                        <td><input type="text" id="username" name="username" value="<%=username%>"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.password"/></td>
                        <td><input type="password" id="password" name="password" value="<%=password%>"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.default.user.repeat.password"/></td>
                        <td><input type="password" id="repeatPassword" name="repeatPassword"/></td>
                    </tr>
                    </tbody>
                </table>

                <table class="styledLeft" id="dbUserTable">
                    <thead>
                    <tr>
                        <th width="20%"><fmt:message key="admin.console.permission.name"/></th>
                        <th width="60%"><fmt:message key="admin.console.value"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.select"/></td>
                        <td><input type="checkbox" id="select_priv" name="select_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.insert"/></td>
                        <td><input type="checkbox" id="insert_priv" name="insert_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.update"/></td>
                        <td><input type="checkbox" id="update_priv" name="update_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.delete"/></td>
                        <td><input type="checkbox" id="delete_priv" name="delete_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.create"/></td>
                        <td><input type="checkbox" id="create_priv" name="create_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.drop"/></td>
                        <td><input type="checkbox" id="drop_priv" name="drop_priv"/></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.reload"/></td>--%>
                        <%--<td><input type="checkbox" id="reload_priv" name="reload_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.shutdown"/></td>--%>
                        <%--<td><input type="checkbox" id="shutdown_priv" name="shutdown_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.process"/></td>--%>
                        <%--<td><input type="checkbox" id="process_priv" name="process_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.file"/></td>--%>
                        <%--<td><input type="checkbox" id="file_priv" name="file_priv"/></td>--%>
                    <%--</tr>--%>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.grant"/></td>
                        <td><input type="checkbox" id="grant_priv" name="grant_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.references"/></td>
                        <td><input type="checkbox" id="references_priv" name="references_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.index"/></td>
                        <td><input type="checkbox" id="index_priv" name="index_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.alter"/></td>
                        <td><input type="checkbox" id="alter_priv" name="alter_priv"/></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.showdb"/></td>--%>
                        <%--<td><input type="checkbox" id="showdb_priv" name="showdb_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.super"/></td>--%>
                        <%--<td><input type="checkbox" id="super_priv" name="super_priv"/></td>--%>
                    <%--</tr>--%>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.create.temp.table"/></td>
                        <td><input type="checkbox" id="create_temp_table_priv" name="create_temp_table_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.lock.tables"/></td>
                        <td><input type="checkbox" id="lock_tables_priv" name="lock_tables_priv"/></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.execute"/></td>--%>
                        <%--<td><input type="checkbox" id="execute_priv" name="execute_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.repl.slave"/></td>--%>
                        <%--<td><input type="checkbox" id="repl_slave_priv" name="repl_slave_priv"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.repl.client"/></td>--%>
                        <%--<td><input type="checkbox" id="repl_client_priv" name="repl_client_priv"/></td>--%>
                    <%--</tr>--%>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.create.view"/></td>
                        <td><input type="checkbox" id="create_view_priv" name="create_view_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.show.view"/></td>
                        <td><input type="checkbox" id="show_view_priv" name="show_view_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.create.routine"/></td>
                        <td><input type="checkbox" id="create_routine_priv" name="create_routine_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.alter.routine"/></td>
                        <td><input type="checkbox" id="alter_routine_priv" name="alter_routine_priv"/></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.create.userInfo"/></td>--%>
                        <%--<td><input type="checkbox" id="create_userinfo_priv" name="create_userinfo_priv"/></td>--%>
                    <%--</tr>--%>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.event"/></td>
                        <td><input type="checkbox" id="event_priv" name="event_priv"/></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.trigger"/></td>
                        <td><input type="checkbox" id="trigger_priv" name="trigger_priv"/></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.ssl.type"/></td>--%>
                        <%--<td><select id="sslTypes" name="sslTypes" onchange="setSSLType()">--%>
                            <%--<option value="">Default</option>--%>
                            <%--<option value="ANY">ANY</option>--%>
                            <%--<option value="X509">X509</option>--%>
                            <%--<option value="SPECIFIED">SPECIFIED</option>--%>
                        <%--</select>--%>
                            <%--<input type="hidden" name="ssl_type" id="ssl_type"/>--%>
                        <%--</td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.ssl.cipher"/></td>--%>
                        <%--<td><input type="text" id="ssl_cipher" name="ssl_cipher" /></td>--%>
                    <%--</tr>--%<tr>
                        <td><fmt:message key="admin.console.permissions.process"/></td>
                        <%if (permissions != null && "Y".equals(permissions.getPermission(AdminConsoleConstants.PROCESS_PRIV).toString())) {%>
                        <td><input type="checkbox" name="process_priv" checked="checked"/></td>
                        <%} else {%>
                        <td><input type="checkbox" name="process_priv"/></td>
                        <%}%>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.permissions.file"/></td>
                        <%if (permissions != null && "Y".equals(permissions.getPermission(AdminConsoleConstants.FILE_PRIV).toString())) {%>
                        <td><input type="checkbox" name="file_priv" checked="checked"/></td>
                        <%} else {%>
                        <td><input type="checkbox" name="file_priv"/></td>
                        <%}%>
                    </tr>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.x509.issuer"/></td>--%>
                        <%--<td><input type="text" id="x509_issuer" name="x509_issuer"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.x509.subject"/></td>--%>
                        <%--<td><input type="text" id="x509_subject" name="x509_subject"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.max.questions"/></td>--%>
                        <%--<td><input type="text" id="maxQuestions" name="maxQuestions"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.max.updates"/></td>--%>
                        <%--<td><input type="text" id="maxUpdates" name="maxUpdates"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.max.connections"/></td>--%>
                        <%--<td><input type="text" id="maxConnections" name="maxConnections"/></td>--%>
                    <%--</tr>--%>
                    <%--<tr>--%>
                        <%--<td><fmt:message key="admin.console.permissions.max.userInfo.connections"/></td>--%>
                        <%--<td><input type="text" id="maxUserConnections" name="maxUserConnections"/></td>--%>
                    <%--</tr>--%>

                    <input id="flag" name="flag" type="hidden" value="add"/>
                    <tr>
                        <td class="buttonRow" colspan="2">
                            <input class="button" type="submit"
                                   value="<fmt:message key="admin.console.save"/>"/>

                            <input class="button" type="button"
                                   value="<fmt:message key="admin.console.cancel"/>" onclick="document.location.href = 'users.jsp'"/>

                        </td>
                    </tr>
                    </tbody>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>

