<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstance" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.RSSInstance" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%
    Log log = LogFactory.getLog(this.getClass());

    String instanceName = request.getParameter("instanceName");
    String dbName = request.getParameter("dbName");
    String flag = request.getParameter("flag");
    String strRssInsId = request.getParameter("rssInsId");
    int rssInsId = (strRssInsId != null) ? Integer.parseInt(strRssInsId) : 0;

    AdminConsoleClient client;
    String msg;

    String backendServerUrl = CarbonUIUtil.getServerURL(
            getServletConfig().getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.
            getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    client = new AdminConsoleClient(cookie, backendServerUrl, configContext);
    if (!"drop".equals(flag)) {
        try {
            RSSInstance rssIns = client.getRSSInstanceById(rssInsId);
            DatabaseInstance db = new DatabaseInstance();
            db.setName(dbName);
            db.setRssInstanceId(rssIns.getRssInstanceId());
            db.setDatabaseInstanceId(0);

            msg = client.createDatabase(db);
            if (msg.contentEquals("Database has been successfully created")) {
%>
<script type="text/javascript">
    CARBON.showConfirmationDialog("Database has been successfully created");
</script>
<%
} else if (msg.contentEquals("A database with the same name already exists")) {
%>
<script type="text/javascript">
    CARBON.showErrorDialog("A database with the same name already exists");
</script>
<%
} else {
%>
<script type="text/javascript">
    CARBON.showErrorDialog("Failed to create the database");
</script>
<%
            }
        }
        catch (Exception e) {
            log.error(e);
        }
    } else {
//        String strRssInsId = request.getParameter("rssInsId");
//        int rssInsId = (strRssInsId == null) ? 0 : Integer.parseInt(strRssInsId);
        String strDatabaseInsId = request.getParameter("dbInsId");
        int dbInsId = (strDatabaseInsId == null) ? 0 : Integer.parseInt(strDatabaseInsId);
        client.dropDatabase(rssInsId, dbInsId);
    }

%>
<script type="text/javascript">
    document.location.href = "databases.jsp?";
</script>
