<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.common.AdminConsoleConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstance" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.DatabaseUser" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.RSSInstance" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.List" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" src="global-params.js"></script>
<script type="text/javascript" src="js/uiValidator.js"></script>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
                       topPage="true"
                       request="<%=request%>"
                       label="Databases"/>
    <%
        final Log log = LogFactory.getLog(this.getClass());

        AdminConsoleClient client = null;
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
                getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String tenantDomain = null;
        try {
            client = new AdminConsoleClient(cookie, backendServerURL, configContext);
            tenantDomain = (String) session.getAttribute("tenantDomain");
        } catch (Exception e) {
            String errorMsg = e.getLocalizedMessage();
            log.error(errorMsg);
        }
    %>

    <div id="middle">
        <h2><fmt:message key="admin.console.databases"/></h2>

        <div id="workArea">
            <form method="post" action="databases.jsp" name="dataForm">
                <table class="styledLeft" id="database_table">
                    <%
                        if (client != null) {
                            List<DatabaseInstance> dbs = client.getDatabaseInstanceList();
                            if (dbs.size() > 0) {
                    %>
                    <thead>
                    <tr>
                        <th><fmt:message key="admin.console.db.name"/></th>
                        <th><fmt:message key="admin.console.instance.name"/></th>
                        <th><fmt:message key="admin.console.tenant.domain"/></th>
                        <th><fmt:message key="admin.console.db.url"/></th>
                        <th><fmt:message key="admin.console.actions"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        for (DatabaseInstance db : dbs) {
                            if (db != null) {
                                RSSInstance rssIns = client.getRSSInstanceById(db.getRssInstanceId());
                                if (rssIns != null) {
                                    if (db.getTenantId() == 0 && AdminConsoleConstants.WSO2_RSS_INSTANCE_TYPE.equals(rssIns.getInstanceType())) {
                                        rssIns.setName(AdminConsoleConstants.WSO2_RSS_INSTANCE_TYPE);
                                    }
                    %>

                    <tr id="tr_<%=rssIns.getRssInstanceId()%>_<%=db.getDatabaseInstanceId()%>">
                        <td><%=db.getName()%>
                        </td>
                        <td><%=rssIns.getName()%>
                        </td>
                        <td><%=client.getTenantDomain(rssIns.getTenantId())%>
                        </td>
                        <td><%=rssIns.getServerURL() + "/" + db.getName()%>
                        </td>
                        <%
                            if (tenantDomain == null) {
                                if (!AdminConsoleConstants.WSO2_USER_DEFINED_INSTANCE_TYPE.equals(
                                        rssIns.getInstanceType()) ||
                                        AdminConsoleConstants.WSO2_LOCAL_RDS_INSTANCE_TYPE.equals(
                                                rssIns.getInstanceType())) {
                        %>
                        <td>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/edit.gif);"
                               onclick="manageDatabase(<%=rssIns.getRssInstanceId()%>,<%=db.getDatabaseInstanceId()%>)"><fmt:message
                                    key="admin.console.manage.database"/></a>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/delete.gif);"
                               onclick="dropDatabase(this)"><fmt:message
                                    key="admin.console.delete.database"/></a>
                        </td>
                    </tr>

                    <%
                        }
                    } else {
//                        if (!AdminConsoleConstants.WSO2_RSS_INSTANCE_TYPE.equals(rssIns.getInstanceType())) {
                    %>
                    <td>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/edit.gif);"
                               onclick="manageDatabase(<%=rssIns.getRssInstanceId()%>,<%=db.getDatabaseInstanceId()%>)"><fmt:message
                                    key="admin.console.manage.database"/></a>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/delete.gif);"
                               onclick="dropDatabase(this)"><fmt:message
                                    key="admin.console.delete.database"/></a>
                        </td>
                    </tr>
                    <%
                                             //   }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    %>
                    <tr>
                        <td class="addNewDatabase" colspan="5">
                            <a class="icon-link"
                               style="background-image:url(../admin/images/add.gif);"
                               href="addDatabase.jsp"><fmt:message
                                    key="admin.console.add.new.database"/></a>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>
