function validateInstanceProperties() {
    var instanceName = trim(document.getElementById("instanceName").value);
    var instanceUrl = trim(document.getElementById("instanceUrl").value);
    var serverCategories = document.getElementById("serverCategory");
    var serverCategory = trim(serverCategories[serverCategories.selectedIndex].value);
    var username = trim(document.getElementById("username").value);
    var password = trim(document.getElementById("password").value);
    //var driverClass = trim(document.getElementById("driverClass").value);
    var databaseEngine = document.getElementById("databaseEngine");
    var instanceType = trim(databaseEngine[databaseEngine.selectedIndex].value);

    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Instance Name Cannot Be Left Blank");
        return false;
    }
    if (instanceType == '' || instanceType == null) {
        CARBON.showWarningDialog("Select A Valid Instance Type");
        return false;
    }
    if (serverCategory == '' || serverCategory == null) {
        CARBON.showWarningDialog("Select A Valid Server Category");
        return false;
    }
    if (instanceUrl == '' || instanceUrl == null) {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return false;
    } else {
        if (instanceUrl.split(":")[0] != 'jdbc') {
            CARBON.showErrorDialog("Invalid Jdbc url");
            return false;
        }
    }
    if (username == '' || username == null) {
        CARBON.showWarningDialog("Master Username Field Cannot Be Left Blank");
        return false;
    }
    if (password == '' || password == null) {
        CARBON.showWarningDialog("Master Password Field Cannot Be Left Blank");
        return false;
    }
    validateConnectionStatus();
    //]return true;
}

function validateEditInstanceProperties() {
    var instanceName = trim(document.getElementById("instanceName").value);
    var instanceUrl = trim(document.getElementById("instanceUrl").value);
    var serverCategories = document.getElementById("serverCategory");
    var serverCategory = trim(serverCategories[serverCategories.selectedIndex].value);
    var username = trim(document.getElementById("username").value);
    var password = trim(document.getElementById("password").value);
    //var driverClass = trim(document.getElementById("driverClass").value);
    var databaseEngine = document.getElementById("databaseEngine");
    var instanceType = trim(databaseEngine[databaseEngine.selectedIndex].value);

    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Instance Name Cannot Be Left Blank");
        return false;
    }
    if (instanceType == '' || instanceType == null) {
        CARBON.showWarningDialog("Select A Valid Instance Type");
        return false;
    }
    if (serverCategory == '' || serverCategory == null) {
        CARBON.showWarningDialog("Select A Valid Server Category");
        return false;
    }
    if (instanceUrl == '' || instanceUrl == null) {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return false;
    } else {
        if (instanceUrl.split(":")[0] != 'jdbc') {
            CARBON.showErrorDialog("Invalid Jdbc url");
            return false;
        }
    }
    if (username == '' || username == null) {
        CARBON.showWarningDialog("Master Username Field Cannot Be Left Blank");
        return false;
    }
    if (password == '' || password == null) {
        CARBON.showWarningDialog("Master Password Field Cannot Be Left Blank");
        return false;
    }
    return true;
    //validateConnectionStatus();
    //]return true;
}

function validateJdbcUrl(url) {
    if (url.split(":")[0] != 'jdbc') {
        CARBON.showErrorDialog("Invalid Jdbc url");
        return false;
    }
    return true;
}

function displayMessages(msg) {
    if (msg.search(/RSS instance has been successfully added/) != -1) {
        // CARBON.showInfoDialog(msg, pageForward());
        jQuery(document).init(function() {
            function handleOK() {
                window.location = 'instances.jsp';
            }

            CARBON.showInfoDialog(msg, handleOK);
        });
    } else {
        if (msg.search(/A database instance with the same name already exists/) != -1) {
            CARBON.showErrorDialog(msg);
        } else {
            if (msg.search(/Database instance has been successfully edited/) != -1) {
                jQuery(document).init(function() {
                    function handleOK() {
                        window.location = 'instances.jsp';
                    }

                    CARBON.showInfoDialog(msg, handleOK);
                });
            } else {
                CARBON.showErrorDialog("Failed to add RSS instance");
            }
        }
    }
}

function displayMessagesForDB(msg) {
    if (msg.search(/Database has been successfully created/) != -1) {
        jQuery(document).init(function() {
            function handleOK() {
                window.location = 'databases.jsp';
            }

            CARBON.showInfoDialog(msg, handleOK);
        });
    } else if (msg.search(/A database with the same name already exists/) != -1) {
        CARBON.showErrorDialog(msg);
    } else {
        CARBON.showErrorDialog('Failed to create a database.')
    }
}

function addDatabases() {
    var instances = document.getElementById("instances").value;
    var dbName = document.getElementById("dbName").value;
    //var flag = document.getElementById("flag").value;
    var url = 'database_ajaxprocessor.jsp?dbName=' + encodeURIComponent(dbName) + '&instances=' + encodeURIComponent(instances);
    jQuery('#connectionStatusDiv').load(url, displayMessages);
}

function validateConnectionStatus() {
    var instanceName = document.getElementById("instanceName").value;
    var instanceUrl = document.getElementById("instanceUrl").value;
    var username = document.getElementById("username").value;
    var password = document.getElementById("password").value;
    var flag = document.getElementById("flag").value;
    var serverCategoryList = document.getElementById("serverCategory");
    var serverCategory = serverCategoryList[serverCategoryList.selectedIndex].value;
    var url = 'connection_status_ajaxprocessor.jsp?instanceName=' + encodeURIComponent(instanceName) + '&instanceUrl=' + encodeURIComponent(instanceUrl) + '&username=' + encodeURIComponent(username) + '&password=' + encodeURIComponent(password) + '&flag=' + encodeURIComponent(flag) + '&serverCategory=' + encodeURIComponent(serverCategory);
    jQuery('#connectionStatusDiv').load(url, displayMessages);
}

function validateDatabaseProperties() {
    var instanceNameBox = document.getElementById("instances");
    var instanceName = trim(instanceNameBox[instanceNameBox.selectedIndex].value);
    var dbName = trim(document.getElementById("dbName").value);

    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Select A Valid Instance Name");
        return false;
    }
    if (dbName == '' || dbName == null) {
        CARBON.showWarningDialog("Database Name Cannot Be Left Blank");
        return false;
    }
    redirectToDatabaseProcessor();

}

function deleteInstance(obj) {
    function forwardToDel() {
        var delElement = document.getElementById(obj);
        var instanceTable = document.getElementById("instanceTable");
        instanceTable.removeChild(delElement);
        document.location.href = "instances.jsp";
    }

    CARBON.showConfirmationDialog("Do you want to drop instance " + obj + "?", forwardToDel());
}

function validateInstanceData() {
    var instanceName = trim(document.getElementById("instanceName").value);
    var instanceUrl = trim(document.getElementById("instanceUrl").value);
    var username = trim(document.getElementById("username").value);
    var password = trim(document.getElementById("password").value);

    if (instanceName == "") {
        CARBON.showWarningDialog("Instance Name Field Cannot Be Left Blank");
        return;
    }
    if (instanceUrl == "") {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return;
    }
    if (username == "") {
        CARBON.showWarningDialog("Username Field Cannot Be Left Blank");
        return;
    }
    if (password == "") {
        CARBON.showWarningDialog("Password Field Cannot Be Left Blank");
        return;
    }
    document.dataForm.action = 'instanceProcessor.jsp';
}

function setJDBCValues(obj, document) {
    var selectedValue = obj[obj.selectedIndex].value;
    var jdbcUrl = selectedValue.substring(0, selectedValue.indexOf("#"));
    //document.getElementById("driverClass").value = selectedValue.substring(selectedValue.indexOf("#") + 1, selectedValue.length);
    document.getElementById("instanceUrl").value = jdbcUrl;
}

function displayMsg(msg) {
    var successMsg = new RegExp("^Database connection is successful with driver class");
    if (msg.search(successMsg) == -1) //if match failed
    {
        CARBON.showErrorDialog(msg);
    } else {
        CARBON.showInfoDialog(msg);
    }

}

function testConnection() {
    var instanceName = trim(document.getElementById("instanceName").value);
    var instanceUrl = trim(document.getElementById("instanceUrl").value);
    var username = trim(document.getElementById("username").value);
    var password = trim(document.getElementById("password").value);
    //var driverClass = trim(document.getElementById("driverClass").value);
    var databaseEngine = document.getElementById("databaseEngine");
    var instanceType = trim(databaseEngine[databaseEngine.selectedIndex].value);

    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Instance Name Cannot Be Left Blank");
        return false;
    }
    if (instanceType == '' || instanceType == null) {
        CARBON.showWarningDialog("Select A Valid Instance Type");
        return false;
    }
    if (instanceUrl == '' || instanceUrl == null) {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return false;
    }
    if (username == '' || username == null) {
        CARBON.showWarningDialog("Master Username Field Cannot Be Left Blank");
        return false;
    }
    if (password == '' || password == null) {
        CARBON.showWarningDialog("Master Password Field Cannot Be Left Blank");
        return false;
    }
    var jdbcUrl = trim(document.getElementById('instanceUrl').value);
    var driverClass = '';
    if (jdbcUrl != null && jdbcUrl != '') {
        driverClass = trim(getJdbcDriver(jdbcUrl));
        if (driverClass != null && driverClass != '') {
            var url = 'connection_test_ajaxprocessor.jsp?driverClass=' + encodeURIComponent(driverClass) + '&jdbcUrl=' +
                    encodeURIComponent(retrieveValidatedUrl(jdbcUrl)) + '&username=' + encodeURIComponent(username) + '&password=' + encodeURIComponent(password);
            jQuery('#connectionTestMsgDiv').load(url, displayMsg);
        } else {
            CARBON.showErrorDialog("Invalid JDBC Url");
        }
    }

    return false;
}

function retrieveValidatedUrl(url) {
    var prefix = url.split(':')[1];
    var hostname = url.split('//')[1].split('/')[0];
    return 'jdbc:' + prefix + "://" + hostname;
}

function dropDatabase(obj) {
    function forwardToDel(){
        var rowId = $(obj).parents('tr:eq(0)').attr('id');
        var temp = rowId.split('_');
        var rssInsId = trim(temp[1]);
        var dbInsId = trim(temp[2]);
        document.location.href = "databaseProcessor.jsp?rssInsId=" + encodeURIComponent(rssInsId) + "&dbInsId=" + encodeURIComponent(dbInsId) + "&flag=drop";
    }
    CARBON.showConfirmationDialog("Do want to drop the database?", forwardToDel);
}

function deleteDatabaseUser(userId, dbInsId, rssInsId){
    function forwardToDel(){
        document.location.href = 'userProcessor.jsp?flag=delete&userId=' + encodeURIComponent(userId) + '&dbInsId=' + encodeURIComponent(dbInsId) + '&rssInsId=' + encodeURIComponent(rssInsId);
    }
    CARBON.showConfirmationDialog("Do you want to drop the user?", forwardToDel);
}

function manageDatabase(rssInsId, dbInsId) {
    document.location.href = 'users.jsp?rssInsId=' + encodeURIComponent(rssInsId) + '&dbInsId=' + encodeURIComponent(dbInsId);
}

function removeInstance(obj, rssInsId) {
    function forwardToDel() {
        var rowId = $(obj).parents('tr:eq(0)').attr('id');
        var instanceName = rowId.substring("tr_".length, rowId.length);
        document.location.href = 'connection_status_ajaxprocessor.jsp?instanceName=' + encodeURIComponent(instanceName) + '&flag=remove&rssInsId=' + encodeURIComponent(rssInsId);
        //document.location.href = "instanceProcessor.jsp?instanceName=" + instanceName + "&flag=remove";
        // jQuery('#connectionStatusDiv').load(url, displayMessages);
    }
    CARBON.showConfirmationDialog('Do you want to delete Database Server Instance?', forwardToDel);
}

function redirectToEditPage(obj, rssInsId) {
    var rowId = $(obj).parents('tr:eq(0)').attr('id');
    var instanceName = rowId.substring("tr_".length, rowId.length);
    /*var url = 'editInstance.jsp?instanceName=' + instanceName + '&flag=edit';
     jQuery('#connectionStatusDiv').load(url, displayMessages);
     */
    document.location.href = "editInstance.jsp?instanceName=" + encodeURIComponent(instanceName) + "&flag=edit&rssInsId=" + encodeURIComponent(rssInsId);
}

function rightTrim(str) {
    for (var i = str.length - 1; i >= 0 && (str.charAt(i) == ' '); i--) {
        str = str.substring(0, i);
    }
    return str;
}

function leftTrim(str) {
    for (var i = 0; i >= 0 && (str.charAt(i) == ' '); i++) {
        str = str.substring(i + 1, str.length);
    }
    return str;
}

function trim(str) {
    return leftTrim(rightTrim(str));
}

function getJdbcDriver(instanceUrl) {
    var prefix = instanceUrl.split(':')[1];
    if (prefix == 'mysql') {
        return 'com.mysql.jdbc.Driver';
    } else if (prefix == 'oracle') {
        return 'oracle.jdbc.driver.OracleDriver';
    }
    return '';
}

function validatePrivileges() {
    var username = trim(document.getElementById('username').value);
    var password = document.getElementById('password').value;
    var repeatPass = document.getElementById('repeatPassword').value;

    if (username == '' || username == null) {
        CARBON.showWarningDialog("Username cannot be left blank");
        return false;
    }
    if (password == '' || password == null) {
        CARBON.showWarningDialog("Password cannot be left blank");
        return false;
    }
    if (repeatPass == '' || repeatPass == null) {
        CARBON.showWarningDialog("Repeat password cannot be left blank");
        return false;
    }
    if (password != repeatPass) {
        CARBON.showErrorDialog("Password and Repeat password values do not match");
        return false;
    }
    return true;
}

function redirectToDatabaseExplorer() {
    href = ""
    document.location.href = "";
}

function populateSelectedUsername() {
    var userList = document.getElementById('users');
    document.getElementById('selectedUsername').value = userList[userList.selectedIndex].value;
}

function forwardToRedirector(rssInstId, dbInstId) {
    var selectedUsername = document.getElementById('selectedUsername');
    document.location.href = 'redirector.jsp?rssInstId=' + encodeURIComponent(rssInstId) + '&dbInstId=' + encodeURIComponent(dbInstId) + '&username=' + encodeURIComponent(selectedUsername);
}

function setHostRssInsname() {
    var hostList = document.getElementById('hosts');
    document.getElementById('hostRssInsId').value = hostList[hostList.selectedIndex].id;

}

function setRssInsId() {
    var rssInsList = document.getElementById("hosts");
    document.getElementById("rssInsId").value = rssInsList[rssInsList.selectedIndex].value;
}

function redirectToDatabaseProcessor() {
    var instanceList = document.getElementById('instances');
    var rssInsId = instanceList[instanceList.selectedIndex].id;
    var dbName = document.getElementById('dbName').value;
    var instanceName = instanceList[instanceList.selectedIndex].value;
    // document.location.href = "databaseProcessor.jsp?instanceName=" + instanceName + "&rssInsId=" + rssInsId + "&dbName=" + dbName;
    var url = 'database_ajaxprocessor.jsp?flag=create&rssInsId=' + encodeURIComponent(rssInsId) + '&dbName=' + encodeURIComponent(dbName);
    jQuery('#connectionStatusDiv').load(url, displayMessagesForDB);
}

function deleteUser(userId) {
    document.location.href = "userProcessor.jsp?flag=delete&userId=" + encodeURIComponent(userId);
}

function setFlag(flag) {
    document.getElementById('flag').value = flag;
}

function setSSLType() {
    var sslTypes = document.getElementById(sslTypes);
    document.getElementById("ssl_type").value = sslTypes[sslTypes.selectedIndex].value;
}

function populateCheckBox(obj, val) {
    if (val == 'Y') {
        obj.checked = true;
    } else if (val == 'N') {
        obj.checked = false;
    }
}

function redirectToPrivilegeGroupsPage(rssInsId, dbInsId){
    document.href.location = 'addPrivilegeGroup.jsp?dbInsId=' + encodeURIComponent(dbInsId) + '&rssInsId=' + encodeURIComponent(rssInsId);
}

function redirectToUsersPage(rssInsId, dbInsId){
    document.href.location = 'newAddUser.jsp?dbInsId=' + encodeURIComponent(dbInsId) + '&rssInsId=' + encodeURIComponent(rssInsId);
}

function setPrivilegeGroup() {
    var privilegeGroups = document.getElementById('privilegeGroups');
    document.getElementById('privilegeGroup').value = privilegeGroups[privilegeGroups.selectedIndex].value;
}

function checkSelectedPrivileges() {
    var isSelected = false;
    var privileges = new Array();
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Insert_priv"));
    privileges.push(document.getElementById("Update_priv"));
    privileges.push(document.getElementById("Delete_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Select_priv"));
    privileges.push(document.getElementById("Lock_tables_priv"));
    privileges.push(document.getElementById("Create_view_priv"));
    privileges.push(document.getElementById("Show_view_priv"));
    privileges.push(document.getElementById("Create_routine_priv"));
    privileges.push(document.getElementById("Alter_routine_priv"));
    privileges.push(document.getElementById("Event_priv"));
    privileges.push(document.getElementById("Trigger_priv"));
    for (var i = 0; i < privileges.length; i++) {
        var val = privileges.pop();
        if (val != '' && val != null) {
             isSelected = true;
        }
    }
    if (!isSelected) {
        CARBON.showWarningDialog("No privilege has been selected. User might not be able to " +
                    "login to the database");
    }
}