<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstance" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.RSSInstance" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" language="JavaScript" src="js/uiValidator.js"></script>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
                       topPage="true" request="<%=request%>" label="admin.console.header"/>

    <%
        Log log = LogFactory.getLog(this.getClass());
        String strDatabaseInsId = request.getParameter("dbInsId");
        int dbInsId = (strDatabaseInsId == null) ? 0 : Integer.parseInt(strDatabaseInsId);
        String strRssInsId = request.getParameter("rssInsId");
        int rssInsId = (strRssInsId == null) ? 0 : Integer.parseInt(strRssInsId);

        String username = request.getParameter("username");
        String password = request.getParameter("password");
        username = (username == null) ? "" : username;
        password = (password == null) ? "" : password;

        AdminConsoleClient client;
        RSSInstance rssIns = null;
        DatabaseInstance db = null;

        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
                getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        try {
            client = new AdminConsoleClient(cookie, backendServerURL, configContext);
            db = client.getDatabaseInstanceInfo(rssInsId, dbInsId);
            rssIns = client.getRSSInstanceById(rssInsId);
        } catch (Exception e) {
            String errorMsg = e.getLocalizedMessage();
        }

    %>

    <div id="middle">
        <h2><fmt:message key="admin.console.user.management"/></h2>

        <div id="workArea">
            <form method="post" name="dataForm">
                <table class="styledLeft" id="dbGeneralInfo">
                    <%--<thead>--%>
                    <%--&lt;%&ndash;<tr>&ndash;%&gt;--%>
                        <%--&lt;%&ndash;<th width="60%"><fmt:message key="admin.console.value"/></th>&ndash;%&gt;--%>
                    <%--&lt;%&ndash;</tr>&ndash;%&gt;--%>
                    <%--</thead>--%>
                    <tbody>

                    <tr>
                        <td><fmt:message key="admin.console.users"/></td>
                        <td><a class="icon-link"
                               style="background-image:url(images/add.gif);"
                               onclick="redirectToUsersPage(<%=rssInsId%>, <%=dbInsId%>)" href="#"><fmt:message
                                    key="admin.console.users"/></a></td>
                    </tr>
                    <tr>
                        <td><fmt:message key="admin.console.user.privilege.groups"/></td>
                        <td><a class="icon-link"
                               style="background-image:url(images/add.gif);"
                               onclick="redirectToPrivilegeGroupsPage(<%=rssInsId%>, <%=dbInsId%>)" href="#"><fmt:message
                                    key="admin.console.user.privilege.groups"/></a></td>
                    </tr>
                    </tbody>
                </table>

                    <input id="flag" name="flag" type="hidden" value="add"/>
                    <tr>
                        <td class="buttonRow" colspan="2">
                            <input class="button" type="submit"
                                   value="<fmt:message key="admin.console.save"/>"/>

                            <input class="button" type="button"
                                   value="<fmt:message key="admin.console.cancel"/>"
                                   onclick="document.location.href = 'users.jsp'"/>

                        </td>
                    </tr>
                    </tbody>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>

