<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.common.CommonUtil" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabasePermissions" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.DatabaseUser" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.io.PrintWriter" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%
    Log log = LogFactory.getLog(this.getClass());
    AdminConsoleClient client;
    String flag = request.getParameter("flag");
    String strDatabaseInsId = request.getParameter("dbInsId");
    int dbInsId = (strDatabaseInsId != null) ? Integer.parseInt(strDatabaseInsId) : 0;
    String strRssInsId = request.getParameter("rssInsId");
    int rssInsId = (strRssInsId != null) ? Integer.parseInt(strRssInsId) : 0;

    String backendServerUrl = CarbonUIUtil.getServerURL(
            getServletConfig().getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.
            getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    client = new AdminConsoleClient(cookie, backendServerUrl, configContext);
    String msg = null;


    if ("add".equals(flag)) {
        try {
            DatabasePermissions permissions = new DatabasePermissions();
            for (String priv : CommonUtil.getDatabasePrivilegesList()) {
                String value = request.getParameter(priv.toLowerCase());
                if (value != null) {
                    if (CommonUtil.booleanResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, "Y");
                    } else if (CommonUtil.blobResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, value);
                    } else if (CommonUtil.integerResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, Integer.parseInt(value));
                    } else if (CommonUtil.stringResponsePrivilges().contains(priv)) {
                        permissions.setPermission(priv, value);
                    }
                } else {
                    if (CommonUtil.booleanResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, "N");
                    } else if (CommonUtil.blobResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, "");
                    } else if (CommonUtil.integerResponsePrivileges().contains(priv)) {
                        permissions.setPermission(priv, 0);
                    } else if (CommonUtil.stringResponsePrivilges().contains(priv)) {
                        permissions.setPermission(priv, "");
                    }
                }
            }

            String username = request.getParameter("username");
            String password = request.getParameter("password");

            DatabaseUser user = new DatabaseUser();
            user.setUsername(username);
            user.setUserId(0);
            user.setPassword(password);
            user.setRssInstanceId(rssInsId);
            msg = client.createUserWithPrivileges(permissions, user, dbInsId);

            response.setContentType("text/xml; charset=UTF-8");
            // Set standard HTTP/1.1 no-cache headers.
            response.setHeader("Cache-Control",
                    "no-store, max-age=0, no-cache, must-revalidate");
            // Set IE extended HTTP/1.1 no-cache headers.
            response.addHeader("Cache-Control", "post-check=0, pre-check=0");
            // Set standard HTTP/1.0 no-cache header.
            response.setHeader("Pragma", "no-cache");

            PrintWriter pw = response.getWriter();
            pw.write(msg);
            pw.flush();
        } catch (Exception e) {
            log.error(e);
        }
    } else if ("delete".equals(flag)) {
        String strUserId = request.getParameter("userId");
        log.error("USER ID : " + strUserId);
        int userId = (strUserId != null) ? Integer.parseInt(strUserId) : 0;
        msg = client.deleteUser(userId, dbInsId);

        response.setContentType("text/xml; charset=UTF-8");
        // Set standard HTTP/1.1 no-cache headers.
        response.setHeader("Cache-Control",
                "no-store, max-age=0, no-cache, must-revalidate");
        // Set IE extended HTTP/1.1 no-cache headers.
        response.addHeader("Cache-Control", "post-check=0, pre-check=0");
        // Set standard HTTP/1.0 no-cache header.
        response.setHeader("Pragma", "no-cache");

        PrintWriter pw = response.getWriter();
        pw.write(msg);
        pw.flush();

    } else if ("edit".equals(flag)) {
        String userIdString = request.getParameter("userId");
        int userId = (userIdString == null) ? 0 : Integer.parseInt(userIdString);
        DatabasePermissions permissions = new DatabasePermissions();
        for (String priv : CommonUtil.getDatabasePrivilegesList()) {
            String value = request.getParameter(priv.toLowerCase());
            if (value != null) {
                if (CommonUtil.booleanResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, "Y");
                } else if (CommonUtil.blobResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, value);
                } else if (CommonUtil.integerResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, Integer.parseInt(value));
                } else if (CommonUtil.stringResponsePrivilges().contains(priv)) {
                    permissions.setPermission(priv, value);
                }
            } else {
                if (CommonUtil.booleanResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, "N");
                } else if (CommonUtil.blobResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, "");
                } else if (CommonUtil.integerResponsePrivileges().contains(priv)) {
                    permissions.setPermission(priv, 0);
                } else if (CommonUtil.stringResponsePrivilges().contains(priv)) {
                    permissions.setPermission(priv, "");
                }
            }
        }

        String username = request.getParameter("username");
        String password = request.getParameter("password");

        DatabaseUser user = new DatabaseUser();
        user.setUsername(username);
        user.setUserId(userId);
        user.setPassword(password);
        user.setRssInstanceId(rssInsId);

        try {
            client.editUserPrivileges(permissions, user, dbInsId);

            response.setContentType("text/xml; charset=UTF-8");
            // Set standard HTTP/1.1 no-cache headers.
            response.setHeader("Cache-Control",
                    "no-store, max-age=0, no-cache, must-revalidate");
            // Set IE extended HTTP/1.1 no-cache headers.
            response.addHeader("Cache-Control", "post-check=0, pre-check=0");
            // Set standard HTTP/1.0 no-cache header.
            response.setHeader("Pragma", "no-cache");

            PrintWriter pw = response.getWriter();
            pw.write(msg);
            pw.flush();
        } catch (Exception e) {
            log.error(e);
        }

    }

%>


