<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstance" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.DatabaseUser" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.stub.types.RSSInstance" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type="text/javascript" src="js/uiValidator.js" language="javascript"></script>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
                       topPage="true" request="<%=request%>" label="admin.console.header"/>

    <div id="middle">
        <h2><fmt:message key="admin.console.users"/></h2>

        <%!
            private String getJdbcDriverName(String url) {
                String driverPrefix = url.split(":")[1];
                if ("mysql".equals(driverPrefix)) {
                    return "com.mysql.jdbc.Driver";
                } else if ("oracle".equals(driverPrefix)) {
                    return "oracle.jdbc.driver.OracleDriver";
                }
                return "";
            }
        %>
        <%
            String strRssInsId = request.getParameter("rssInsId");
            int rssInsId = (strRssInsId != null) ? Integer.parseInt(strRssInsId) : 0;
            String strDatabaseInsId = request.getParameter("dbInsId");
            int dbInsId = (strDatabaseInsId != null) ? Integer.parseInt(strDatabaseInsId) : 0;
            final Log log = LogFactory.getLog(this.getClass());

            AdminConsoleClient client = null;
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            String tenantDomain = null;
            try {
                client = new AdminConsoleClient(cookie, backendServerURL, configContext);
                tenantDomain = (String) session.getAttribute("tenantDomain");
            } catch (Exception e) {
                String errorMsg = e.getLocalizedMessage();
                log.error(errorMsg);
            }
        %>
        <div id="workArea">
            <form method="post" action="userProcessor.jsp" name="dataForm">
                <table class="styledLeft" id="dbUserTable">
                    <%
                        if (client != null) {
                            DatabaseUser[] users = client.getUsersByDatabase(dbInsId);
                            if (users != null && users.length > 0) {
                    %>
                    <thead>
                    <tr>
                            <%--<th width="20%"><fmt:message key="admin.console.db.name"/></th>--%>
                        <th width="20%"><fmt:message key="admin.console.user"/></th>
                        <th width="60%"><fmt:message key="admin.console.actions"/></th>
                            <%--<th width="60%"><fmt:message key="admin.console.default.user.flag"/></th>--%>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        int i = 1;
                    %>
                    <form method="post" id="adminConsoleForm0" name="adminConsoleForm0"
                          action="../dbconsole/login.jsp"></form>
                    <script language="JavaScript" type="text/javascript">
                        document.forms['adminConsoleForm0'].submit();
                    </script>
                    <%
                        for (DatabaseUser user : users) {
                            if (user != null) {
                                RSSInstance rssIns = client.getRSSInstanceById(rssInsId);
                                DatabaseInstance db = client.getDatabaseInstanceInfo(rssInsId, dbInsId);
                    %>
                    <tr>
                        <td id="<%=user.getUserId()%>"><%=user.getUsername()%>
                        </td>

                        <form method="post" action="../dbconsole/login.jsp"
                              name="<%="adminConsoleForm"+String.valueOf(i)%>">

                            <input type="hidden" id="password" name="password"
                                   value="<%=user.getPassword()%>"/>
                            <input type="hidden" id="url" name="url"
                                   value="<%=rssIns.getServerURL() + "/" + db.getName()%>"/>
                            <input type="hidden" id="user" name="user"
                                   value="<%=user.getUsername()%>"/>
                            <input type="hidden" id="driver" name="driver"
                                   value="<%=this.getJdbcDriverName(rssIns.getServerURL())%>"/>

                            <td>
                                <a href="#"
                                   id="adminConsole"
                                   onclick="document.forms['<%="adminConsoleForm"+String.valueOf(i)%>'].submit();"
                                   style="background-image: url(../adminconsole/images/db-exp.png);"
                                   class="icon-link" type="submit"> <fmt:message
                                        key="admin.console.explore.database"/>
                                </a>
                                <a class="icon-link"
                                  style="background-image:url(../adminconsole/images/data-sources-icon.gif);"
                                  href="userProcessor.jsp?rssInsId=<%=user.getRssInstanceId()%>&username=<%=user.getUsername()%>&password=<%=user.getPassword()%>&dsName=<%=db.getName() + "_" + user.getUserId()%>&dbInsId=<%=db.getDatabaseInstanceId()%>&dbName=<%=db.getName()%>&flag=createDS"><fmt:message
                                       key="admin.console.create.datasource"/></a>
                                <a class="icon-link"
                                   style="background-image:url(../admin/images/edit.gif);"
                                   href="editUser.jsp?dbInsId=<%=dbInsId%>&rssInsId=<%=rssInsId%>&username=<%=user.getUsername()%>&userId=<%=user.getUserId()%>"><fmt:message
                                        key="admin.console.edit.user"/></a>
                                <a class="icon-link"
                                   style="background-image:url(../admin/images/delete.gif);"
                                   onclick="deleteDatabaseUser(<%=user.getUserId()%>,<%=dbInsId%>,<%=user.getRssInstanceId()%>)"
                                   href="#"><fmt:message
                                        key="admin.console.delete.database"/></a>
                            </td>

                        </form>

                    </tr>

                    <%
                                    }
                                    i++;
                                }
                            }
                        }
                    %>
                    <tr>
                        <td class="addUser" colspan="3">
                            <a class="icon-link"
                               style="background-image:url(../admin/images/add.gif);"
                               href="addUser.jsp?dbInsId=<%=dbInsId%>&rssInsId=<%=rssInsId%>"><fmt:message
                                    key="admin.console.add.new.user"/></a>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <table>
                    <tr>
                        <input class="button" type="button"
                               value="<fmt:message key="admin.console.back"/>"
                               onclick="document.location.href = 'databases.jsp'"/>
                    </tr>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>